# utente.s
#
#define ASM 1
#include <costanti.h>

# Tipi di interruzione per le chiamate di sistema e per le primitive di IO
#

.set tipo_a, TIPO_A
.set tipo_t, TIPO_T
.set tipo_si, TIPO_SI
.set tipo_w, TIPO_W
.set tipo_s, TIPO_S
.set tipo_d, TIPO_D
.set tipo_rl, TIPO_RL
.set tipo_re, TIPO_RE
.set tipo_l, TIPO_L
.set tipo_ep, TIPO_EP
.set tipo_dm, TIPO_DM
.set tipo_ud,  TIPO_UD
.set tipo_getid, TIPO_GETID
.set tipo_getidp, TIPO_GETIDP

.set io_tipo_pcir, IO_TIPO_PCIR
.set io_tipo_rsen, IO_TIPO_RSEN
.set io_tipo_rseln, IO_TIPO_RSELN
.set io_tipo_wsen, IO_TIPO_WSEN
.set io_tipo_wse0, IO_TIPO_WSE0
.set io_tipo_tr, IO_TIPO_TR
.set io_tipo_trl, IO_TIPO_TRL
.set io_tipo_tw, IO_TIPO_TW
.set io_tipo_rkbd, IO_TIPO_RKBD
.set io_tipo_ikbd, IO_TIPO_IKBD
.set io_tipo_wfikbd, IO_TIPO_WFIKBD
.set io_tipo_skbd, IO_TIPO_SKBD
.set io_tipo_smon, IO_TIPO_SMON
.set io_tipo_wmon, IO_TIPO_WMON
.set io_tipo_wcon, IO_TIPO_WCON
.set io_tipo_inic, IO_TIPO_INIC
.set io_tipo_cmon, IO_TIPO_CMON
.set io_tipo_gmon, IO_TIPO_GMON
.set io_tipo_lkbd, IO_TIPO_LKBD
.set io_tipo_kmon, IO_TIPO_KMON
.set io_tipo_pkbd, IO_TIPO_PKBD
.set io_tipo_rcon, IO_TIPO_RCON

#tipi per le primitive di trasmissione/ricezione eth
.set io_tipo_ethr, IO_TIPO_ETHR
.set io_tipo_etht, IO_TIPO_ETHT

#if 0
.set io_tipo_ak_set, 	IO_TIPO_AK_SET
.set io_tipo_ak_get, 	IO_TIPO_AK_GET
#endif
.set io_tipo_sndcommand, IO_TIPO_SNDCOMMAND
.set io_tipo_play, 	IO_TIPO_PLAY
#date e time 
.set io_tipo_get_time,  IO_TIPO_TIME 
.set io_tipo_get_date, IO_TIPO_DATE

#fs 
.set tipo_open   ,  TIPO_OPEN 
.set tipo_close  ,  TIPO_CLOSE 
.set tipo_read   ,  TIPO_READ 
.set tipo_write  ,  TIPO_WRITE 
.set tipo_lseek  ,  TIPO_LSEEK 
.set tipo_remove ,  TIPO_REMOVE
.set tipo_rename ,  TIPO_RENAME 
.set tipo_rmdir  , TIPO_RMDIR
.set tipo_chdir  , TIPO_CHDIR 
.set tipo_mkdir  , TIPO_MKDIR 
.set tipo_get_cwd , TIPO_GETCWD
.set tipo_err,   TIPO_ERR

# mouse
.set io_tipo_getme,	IO_TIPO_GETME

	.text

	.global activate_p
activate_p:
	int $tipo_a
	ret

	.global terminate_p
terminate_p:
	int $tipo_t
	ret

	.global end_program
end_program:
	int $tipo_ep
	ret

	.global sem_ini
sem_ini:
	int $tipo_si
	ret

	.global sem_wait
sem_wait:
	int $tipo_w
	ret

	.global sem_signal
sem_signal:
	int $tipo_s
	ret

	.global delay
delay:
	int $tipo_d
	ret

	.global udelay
udelay:
	int $tipo_ud
	ret

	.global dump
dump:
	int $tipo_dm
	ret

	.global pci_read
pci_read:
	int $io_tipo_pcir
	ret

	.global readse_n
readse_n:
	int $io_tipo_rsen
	ret

	.global readse_ln
readse_ln:
	int $io_tipo_rseln
	ret

	.global writese_n
writese_n:
	int $io_tipo_wsen
	ret

	.global writese_0
writese_0:
	int $io_tipo_wse0
	ret

	.global readconsole
readconsole:
	int $io_tipo_rcon
	ret

	.global writeconsole
writeconsole:
	int $io_tipo_wcon
	ret

	.global iniconsole
iniconsole:
	int $io_tipo_inic
	ret

	.global vkbd_read
vkbd_read:
	int $io_tipo_rkbd
	ret

	.global vkbd_intr_enable	
vkbd_intr_enable:
	int $io_tipo_ikbd
	ret

	.global vkbd_wfi
vkbd_wfi:
	int $io_tipo_wfikbd
	ret

	.global vkbd_send
vkbd_send:
	int $io_tipo_pkbd
	ret

	.global vkbd_switch
vkbd_switch:
	int $io_tipo_skbd
	ret

	.global vmon_switch
vmon_switch:
	int $io_tipo_smon
	ret

	.global vmon_write_n
vmon_write_n:
	int $io_tipo_wmon
	ret

	.global vmon_setcursor
vmon_setcursor:
	int $io_tipo_cmon
	ret

	.global vmon_getsize
vmon_getsize:
	int $io_tipo_gmon
	ret

	.global vmon_cursor_shape
vmon_cursor_shape:
	int $io_tipo_kmon
	ret

	.global vkbd_leds
vkbd_leds:
	int $io_tipo_lkbd
	ret


	.global eth_receive
eth_receive:
	int $io_tipo_ethr
	ret
	
	.global eth_transmit
eth_transmit:
	int $io_tipo_etht
	ret

	.global readlog
readlog:
	int $tipo_rl
	ret

	.global resident
resident:
	int $tipo_re
	ret

	.global log
log:
	int $tipo_l
	ret

#if 0
	.global setMixer
setMixer:
	int $io_tipo_ak_set
	ret
	
	.global getMixer
getMixer:
	int $io_tipo_ak_get
	ret	
#endif	
	
	.global sndcommand
sndcommand:
	int $io_tipo_sndcommand
	ret	

	
	.global play
play:
	int $io_tipo_play
	ret		

	.global get_mouse_events
get_mouse_events:
	int $io_tipo_getme
	ret

	.global _start, start
_start:
start:
	call lib_init
	jmp main

	.global get_id
get_id:
	int $tipo_getid
	ret

	.global get_id_p
get_id_p:
	int $tipo_getidp
	ret
	.global get_time 
get_time : 
	int $io_tipo_get_time 
	ret
	.global get_date
get_date : 
	int $io_tipo_get_date
	ret  

//FS 
	.global open
open : 
	int $tipo_open
	ret  

	.global close
close: 
	int $tipo_close
	ret  

	.global read
read : 
	int $tipo_read
	ret  

	.global write
write : 
	int $tipo_write
	ret  

	.global lseek
lseek : 
	int $tipo_lseek
	ret  


	.global remove
remove : 
	int $tipo_remove
	ret  

	.global mkdir
mkdir : 
	int $tipo_mkdir
	ret  

	.global chdir
chdir : 
	int $tipo_chdir
	ret  

	.global rmdir
rmdir : 
	int $tipo_rmdir
	ret  

	.global getcwd
getcwd : 
	int $tipo_get_cwd
	ret  

      .global get_error
get_error: 
      int $tipo_err
      ret
      
       .global rename
rename : 
	int $tipo_rename
	ret 
